
/*
 * ConntactPanel.java
 *
 * Created on 2011-maj-10, 11:43:23
 */
package se.softstuff.nb.corecomponent.api;

import java.util.Locale;
import org.openide.util.editable.NbBundle;

/**
 *
 * @author stefan
 */
public class ContactPanel extends javax.swing.JPanel {

    public static final String PROP_CONTACTNAME = "contactName"; // NOI18N

    public static final String PROP_CONTACTPHONE = "contactPhone";// NOI18N

    public static final String PROP_CONTACTEMAIL = "contactEmail";// NOI18N

    public static final String PROP_CONTACTCOUNTRY = "contactCountry";// NOI18N

    public static final String PROP_ISMALE = "contactMale";

    protected String contactName;

    private String contactCountry;

    protected String contactPhone;

    private String contactEmail;

    private boolean contactMale;
    

    public String getContactName() {
        return contactName;
    }

    public void setContactName(String contactName) {
        String oldContactName = this.contactName;
        this.contactName = contactName;
        firePropertyChange(PROP_CONTACTNAME, oldContactName, contactName);
    }

    public String getContactPhone() {
        return contactPhone;
    }

    public void setContactPhone(String contactPhone) {
        String oldContactPhone = this.contactPhone;
        this.contactPhone = contactPhone;
        firePropertyChange(PROP_CONTACTPHONE, oldContactPhone, contactPhone);
    }

    public String getContactEmail() {
        return contactEmail;
    }

    public void setContactEmail(String contactEmail) {
        String oldContactEmail = this.contactEmail;
        this.contactEmail = contactEmail;
        firePropertyChange(PROP_CONTACTEMAIL, oldContactEmail, contactEmail);
    }

    public String getContactCountry() {
        return contactCountry;
    }

    public void setContactCountry(String contactCountry) {
        String oldContactCountry = this.contactCountry;
        this.contactCountry = contactCountry;
        firePropertyChange(PROP_CONTACTCOUNTRY, oldContactCountry, contactCountry);
    }

    public final boolean isContactMale() {
        return contactMale;
    }

    public void setIsMale(boolean contactMale) {
        boolean oldContactMale = this.contactMale;
        this.contactMale = contactMale;
        firePropertyChange(PROP_ISMALE, oldContactMale, contactMale);
        
        
    }
    

    /** Creates new form ConntactPanel */
    public ContactPanel() {
        initComponents();
        maleRadioButton.setSelected(isContactMale());
    }

    public ContactPanel(String contactName, String contactCountry, String contactPhone, String contactEmail, boolean contactMale) {
        this.contactName = contactName;
        this.contactCountry = contactCountry;
        this.contactPhone = contactPhone;
        this.contactEmail = contactEmail;
        this.contactMale = contactMale;
        
        initComponents();
        
        maleRadioButton.setSelected(isContactMale());
    }
    

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        bindingGroup = new org.jdesktop.beansbinding.BindingGroup();

        genderGroup = new javax.swing.ButtonGroup();
        nameLabel = new javax.swing.JLabel();
        nameTextField = new javax.swing.JTextField();
        phoneTextField = new javax.swing.JTextField();
        phoneLabel = new javax.swing.JLabel();
        emailTextField = new javax.swing.JTextField();
        emailLabel = new javax.swing.JLabel();
        countryTextField = new javax.swing.JTextField();
        countryLabel = new javax.swing.JLabel();
        maleRadioButton = new javax.swing.JRadioButton();
        femaleRadioButton = new javax.swing.JRadioButton();

        setName("Form"); // NOI18N

        nameLabel.setLabelFor(nameTextField);
        org.openide.awt.Mnemonics.setLocalizedText(nameLabel, NbBundle.getMessage(ContactPanel.class, "ContactPanel.nameLabel.text", Locale.getDefault().getDisplayLanguage())); // NOI18N
        nameLabel.setName("nameLabel"); // NOI18N

        nameTextField.setName("nameTextField"); // NOI18N

        org.jdesktop.beansbinding.Binding binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, this, org.jdesktop.beansbinding.ELProperty.create("${contactName}"), nameTextField, org.jdesktop.beansbinding.BeanProperty.create("text"));
        bindingGroup.addBinding(binding);

        phoneTextField.setName("phoneTextField"); // NOI18N

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, this, org.jdesktop.beansbinding.ELProperty.create("${contactPhone}"), phoneTextField, org.jdesktop.beansbinding.BeanProperty.create("text"));
        bindingGroup.addBinding(binding);

        phoneLabel.setLabelFor(phoneTextField);
        org.openide.awt.Mnemonics.setLocalizedText(phoneLabel, NbBundle.getMessage(ContactPanel.class, "ContactPanel.phoneLabel.text", Locale.getDefault().getDisplayLanguage())); // NOI18N
        phoneLabel.setName("phoneLabel"); // NOI18N

        emailTextField.setName("emailTextField"); // NOI18N

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, this, org.jdesktop.beansbinding.ELProperty.create("${contactEmail}"), emailTextField, org.jdesktop.beansbinding.BeanProperty.create("text"));
        bindingGroup.addBinding(binding);

        emailLabel.setLabelFor(emailTextField);
        org.openide.awt.Mnemonics.setLocalizedText(emailLabel, NbBundle.getMessage(ContactPanel.class, "ContactPanel.emailLabel.text", Locale.getDefault().getDisplayLanguage())); // NOI18N
        emailLabel.setName("emailLabel"); // NOI18N

        countryTextField.setName("countryTextField"); // NOI18N

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, this, org.jdesktop.beansbinding.ELProperty.create("${contactCountry}"), countryTextField, org.jdesktop.beansbinding.BeanProperty.create("text"));
        bindingGroup.addBinding(binding);

        countryLabel.setLabelFor(countryTextField);
        org.openide.awt.Mnemonics.setLocalizedText(countryLabel, NbBundle.getMessage(ContactPanel.class, "ContactPanel.countryLabel.text", Locale.getDefault().getDisplayLanguage())); // NOI18N
        countryLabel.setName("countryLabel"); // NOI18N

        genderGroup.add(maleRadioButton);
        org.openide.awt.Mnemonics.setLocalizedText(maleRadioButton, NbBundle.getMessage(ContactPanel.class, "ContactPanel.maleRadioButton.text", Locale.getDefault().getDisplayLanguage())); // NOI18N
        maleRadioButton.setName("maleRadioButton"); // NOI18N
        maleRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                maleRadioButtonActionPerformed(evt);
            }
        });

        genderGroup.add(femaleRadioButton);
        org.openide.awt.Mnemonics.setLocalizedText(femaleRadioButton, NbBundle.getMessage(ContactPanel.class, "ContactPanel.femaleRadioButton.text", Locale.getDefault().getDisplayLanguage())); // NOI18N
        femaleRadioButton.setName("femaleRadioButton"); // NOI18N
        femaleRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                femaleRadioButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(phoneLabel)
                    .addComponent(nameLabel)
                    .addComponent(emailLabel)
                    .addComponent(countryLabel))
                .addGap(29, 29, 29)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(maleRadioButton, javax.swing.GroupLayout.PREFERRED_SIZE, 87, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(femaleRadioButton))
                    .addComponent(emailTextField, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 192, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(phoneTextField, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 192, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(nameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 192, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(countryTextField, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 192, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(21, Short.MAX_VALUE))
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {femaleRadioButton, maleRadioButton});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(nameLabel)
                    .addComponent(nameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(phoneLabel)
                    .addComponent(phoneTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(emailLabel)
                    .addComponent(emailTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(countryLabel)
                    .addComponent(countryTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(femaleRadioButton)
                    .addComponent(maleRadioButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        bindingGroup.bind();
    }// </editor-fold>//GEN-END:initComponents

    private void maleRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_maleRadioButtonActionPerformed
        setIsMale(maleRadioButton.isSelected());
    }//GEN-LAST:event_maleRadioButtonActionPerformed

    private void femaleRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_femaleRadioButtonActionPerformed
        setIsMale(maleRadioButton.isSelected());
    }//GEN-LAST:event_femaleRadioButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel countryLabel;
    private javax.swing.JTextField countryTextField;
    private javax.swing.JLabel emailLabel;
    private javax.swing.JTextField emailTextField;
    private javax.swing.JRadioButton femaleRadioButton;
    private javax.swing.ButtonGroup genderGroup;
    private javax.swing.JRadioButton maleRadioButton;
    private javax.swing.JLabel nameLabel;
    private javax.swing.JTextField nameTextField;
    private javax.swing.JLabel phoneLabel;
    private javax.swing.JTextField phoneTextField;
    private org.jdesktop.beansbinding.BindingGroup bindingGroup;
    // End of variables declaration//GEN-END:variables
}
